# Copyright (C) 2001-2004 All right reserved by Shinya Kondo ( CGI KON )

	require "timelocal.pl";
	require "sample.inc" if(-e "sample.inc");

# 

	$SOFT_TITLE = qq!ڶͭͽɽ!;

	$PAGE_TITLE = qq!ͽ!;

	$COPY_TITLE = qq!Powered by CGIKON!;

	@LIST_WEEKS = ("","","","","","","");
	@LIST_COLOR = ("#FF0000","#000000","#000000","#000000","#000000","#000000","#0000FF");
	@LIST_CELLS = ("#FFDBDB","#F5F5F5","#F5F5F5","#F5F5F5","#F5F5F5","#F5F5F5","#BFEEEE");

	%HASH_TITLE = ("VIEW" => 'ɽ',"EDIT" => 'ɽ');

# üʸѴ

sub HTML_Chars
{
	my($value) = @_;

	$value =~ s/&/&amp;/g;
	$value =~ s/"/&quot;/g;
	$value =~ s/</&lt;/g;
	$value =~ s/>/&gt;/g;

	return $value;
}

# վμ

sub Get_Date
{
	my($yyyy,$mm) = @_;

	my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst,$days);
	my(@column) = (0,31,28,31,30,31,30,31,31,30,31,30,31);

	if($yyyy == "" || $mm == "") {
		($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time());
		$yyyy = $year + 1900;
		$mm = $mon + 1;
	}

	my($time) = timelocal(0,0,0,1,$mm - 1,$yyyy);
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($time);
	$yyyy = $year + 1900;
	$mm = $mon + 1;

	if($mm != 2) {
		$days = $column[$mm]
	} elsif($yyyy % 400 == 0) {
		$days = 29;
	} elsif($yyyy % 100 == 0) {
		$days = 28;
	} elsif($yyyy % 4 == 0) {
		$days = 29;
	} else {
		$days = 28;
	}

	return ($yyyy,$mm,$days,$wday);
}

# ̾ξμ

sub Get_Names
{
	my($file) = @_;

	my($k_id,$name,$pass,$memo,%result);

	if(open(IFILE,$file)) {
		while(<IFILE>) {
			chomp();
			($k_id,$name,$pass,$memo) = split("\t");
			$result{$k_id}{"NAME"} = $name;
			$result{$k_id}{"PASS"} = $pass;
			$result{$k_id}{"MEMO"} = $memo;
		}
		close(IFILE);
	}

	return %result;
}

# ͽ

sub Set_Names
{
	my(%value) = @_;

	my($k_id,$name,$pass,$memo,$buff,@result);

	while(($k_id,$buff) = each(%value)) {
		$name = $value{$k_id}{"NAME"};
		$pass = $value{$k_id}{"PASS"};
		$memo = $value{$k_id}{"MEMO"};
		push(@result,join("\t",$k_id,$name,$pass,$memo));
	}

	return @result;
}

# ץμ

sub Get_Sample
{
	my(%value) = @_;

	return %value if(!$SAMPLE_TITLE);

	my($key,$val,%result);

	my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	$year += 1900;

	$result{"NOTE"} = $value{"NOTE"};

	while(($key,$val) = each(%value)) {
		$key =~ s/YYYY/$year/;
		$result{$key} = $val;
	}

	return %result;
}

# ͽμ

sub Get_Memos
{
	my($file) = @_;

	my($date,$memo,%result);

	if(open(IFILE,$file)) {
		while(<IFILE>) {
			chomp();
			($date,$memo) = split("\t");
			$result{$date} = $memo;
		}
		close(IFILE);
	}

	return &Get_Sample(%result);
}

# ͽ

sub Set_Memos
{
	my(%value) = @_;

	my($date,$memo,@result);

	while(($date,$memo) = each(%value)) {
		next if(!$memo);
		push(@result,join("\t",$date,$memo));
	}

	return @result;
}

# ͽκ

sub Del_Memos
{
	my($yyyy,$mm,%value) = @_;

	my($date,$memo,@result);
	my($key1,$key2,$key3,$vals);

	push(@result,join("\t","NOTE",$value{"NOTE"}));

	$vals = $yyyy * 100 + $mm;
	while(($date,$memo) = each(%value)) {
		($key1,$key2,$key3) = split("/",$date);
		next if($key1 * 100 + $key2 <= $vals);
		push(@result,join("\t",$date,$memo));
	}

	return @result;
}

# ȥСɽ

sub Print_Bar
{
	my($admin) = @_;

	return if(!$admin);

	my($title) = $HASH_TITLE{$admin};
	return if(!$title);

	print qq!
	<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=5>
	<TR>
		<TD BGCOLOR="Yellow">
			<FONT COLOR="Blue"><B>$title</B></FONT>
		</TD>
	</TR>
	</TABLE>
	!;
}

# ƥΥ

sub Print_Item
{
	my($link,$item) = @_;

	my($key,$href,$name);

	print qq!
		<TABLE BORDER=0 BGCOLOR="#FFFFFF" WIDTH="90%" CELLPADDING="5" CELLSPACING="0">
		<TR>
		<TD>
	!;

	foreach $key (sort(keys %HASH_NAMES)) {
		$name = $HASH_NAMES{$key}{"NAME"};
		if($key == $item) {
			print qq!<FONT SIZE=3 COLOR="black"><B>$name</B></FONT>!;
			next;
		}

		$href = $link."item=$key";
		print qq!
		<A HREF="$href"><FONT SIZE=2 COLOR="blue">$name</FONT></A>
		!;
	}

	print qq!
		</TD>
		</TR>
		</TABLE>
	!;
}

# ڡΥ

sub Print_Page
{
	my($link,$page,$max) = @_;

	my($loop,$href);

	print qq!
		<TABLE BORDER=0 BGCOLOR="#FFFFFF" WIDTH="60%" CELLPADDING="5" CELLSPACING="0">
		<TR ALIGN="center">
		<TD>
			<FONT SIZE=2>ڡ</FONT>
	!;

	for($loop = 1;$loop <= $max;$loop++) {
		if($loop == $page) {
			print qq!<FONT SIZE=3 COLOR="black"><B>[ $loop ]</B></FONT>!;
			next;
		}

		$href = $link."page=$loop";
		print qq!
		<A HREF="$href"><FONT SIZE=2 COLOR="blue">[ $loop ]</FONT></A>
		!;
	}

	print qq!
		
		</TD>
		</TR>
		</TABLE>
	!;
}

# ѥɥå

sub Check_Pass
{
	my($item,$pass) = @_;

	my($keys);

	$keys = $HASH_NAMES{$item}{"PASS"};
	return if($keys && $pass eq $keys);

	require "user_01.inc";
	exit;
}

# ǯΥ

sub Print_Date
{
	my($link,$yyyy,$mm,$jump,$mesg) = @_;

	my($loop,$href);

	print qq!
		<TABLE BORDER="0" CELLPADDING="5" CELLSPACING="0" WIDTH="90%">
		<TR>
			<TD WIDTH="30%"></TD>
			<TD COLSPAN=4 ALIGN="left"><INPUT TYPE="submit" NAME="last" VALUE="ǯ"></TD>
			<TD COLSPAN=4 ALIGN="center"><FONT SIZE=3 COLOR="black"><B>$yyyyǯ</B></FONT></TD>
			<TD COLSPAN=4 ALIGN="right"><INPUT TYPE="submit" NAME="next" VALUE="ǯ"></TD>
			<TD WIDTH="30%"></TD>
		</TR>
		<TR>
			<TD WIDTH="30%"></TD>
	!;

	for($loop = 1;$loop <= 12;$loop++) {
		$href = $link."yyyy=$yyyy&mm=$loop";
		if($loop == $mm) {
			print qq!<TD NOWRAP><FONT SIZE=3 COLOR="black"><B>$loop</B></FONT></TD>!;
		} else {
			print qq!<TD NOWRAP><A HREF="$href"><FONT SIZE=2 COLOR="blue">$loop</FONT></A></TD>!;
		}
	}

	print qq!
			<TD WIDTH="30%" ALIGN="right" NOWRAP>$jump $mesg</TD>
		</TR>
		</TABLE>
	!;
}

# ͽƤɽ

sub Print_Memo_1
{
	my($item,$yyyy,$mm,$mday,$href) = @_;

	my($loop,$week,$dd,$link,$days,$date,@TB_COLOR,@TB_WEEKS,@TB_CELLS,@TB_LINKS);

	for($loop = 1;$loop <= 31;$loop++) {
		$week = ($loop + $wday - 1) % 7;
		$TB_COLOR[$loop] = $LIST_COLOR[$week];
		$TB_WEEKS[$loop] = $LIST_WEEKS[$week];
		$TB_CELLS[$loop] = $LIST_CELLS[$week];
	}

	foreach(@LIST_RESTS) {
		chomp();
		@column = split("/");
		if(int($column[0]) == $yyyy && int($column[1]) == $mm) {
			$dd = int($column[2]);
			$TB_COLOR[$dd] = $LIST_COLOR[0];
			$TB_CELLS[$dd] = $LIST_CELLS[0];
		}
	}

	if($href) {
		for($loop = 1;$loop <= $mday;$loop++) {
			$TB_LINKS[$loop] = '<A HREF="'.$href."yyyy=$yyyy&mm=$mm&dd=$loop&edit=TRUE".'">';
		}
		$href = "</A>";
	}

	for($loop = 1;$loop <= $mday;$loop++) {
		$link = $TB_LINKS[$loop].'<FONT COLOR="#808080"><B>'.$loop.'</B></FONT>'.$href;
		$days = '<FONT COLOR="'.$TB_COLOR[$loop].'">'.$TB_WEEKS[$loop].'</FONT>';
		$date = sprintf("%4d/%02d/%02d",$yyyy,$mm,$loop);

		print qq!
		<TR>
			<TD BGCOLOR="#F5F5F5" ALIGN="right" WIDTH="1%" NOWRAP>$link</TD>
			<TD BGCOLOR="$TB_CELLS[$loop]" ALIGN="right" WIDTH="1%" NOWRAP>$days</TD>
			<TD COLSPAN=4 WIDTH="98%">$LIST_MEMOS{$date}</TD>
		</TR>
		!;
	}
}

# ͽƤɽ

sub Print_Memo_2
{
	my($item,$yyyy,$mm,$mday,$href) = @_;

	my($loop,$week,$dd,$link,$days,$date,@TB_COLOR,@TB_WEEKS,@TB_CELLS,@TB_LINKS);

	for($loop = 1;$loop <= 31;$loop++) {
		$week = ($loop + $wday - 1) % 7;
		$TB_WORDS[$loop] = $loop;
		$TB_COLOR[$loop] = $LIST_COLOR[$week];
		$TB_WEEKS[$loop] = $LIST_WEEKS[$week];
		$TB_CELLS[$loop] = $LIST_CELLS[$week];
	}

	foreach(@LIST_RESTS) {
		chomp();
		@column = split("/");
		if(int($column[0]) == $yyyy && int($column[1]) == $mm) {
			$dd = int($column[2]);
			$TB_COLOR[$dd] = $LIST_COLOR[0];
			$TB_CELLS[$dd] = $LIST_CELLS[0];
		}
	}

	if($href) {
		for($loop = 1;$loop <= $mday;$loop++) {
			$TB_LINKS[$loop] = '<A HREF="'.$href."yyyy=$yyyy&mm=$mm&dd=$loop&edit=TRUE".'">';
		}
		$href = "</A>";
	}

	for($loop = $mday + 1;$loop <= 31;$loop++) {
		$TB_WORDS[$loop] = '';
		$TB_WEEKS[$loop] = '';
		$TB_CELLS[$loop] = "#F5F5F5";
		$date = sprintf("%4d/%02d/%02d",$yyyy,$mm,$loop);
		$LIST_MEMOS{$date} = '';
	}

	for($loop = 1;$loop <= 15;$loop++) {
		$dd = $loop;
		$link = $TB_LINKS[$dd].'<FONT COLOR="#808080"><B>'.$TB_WORDS[$dd].'</B></FONT>'.$href;
		$days = '<FONT COLOR="'.$TB_COLOR[$dd].'">'.$TB_WEEKS[$dd].'</FONT>';
		$date = sprintf("%4d/%02d/%02d",$yyyy,$mm,$dd);

		print qq!
		<TR>
			<TD BGCOLOR="#F5F5F5" ALIGN="right" WIDTH="1%" NOWRAP>$link</TD>
			<TD BGCOLOR="$TB_CELLS[$dd]" ALIGN="right" WIDTH="1%" NOWRAP>$days</TD>
			<TD WIDTH="48%">$LIST_MEMOS{$date}</TD>
		!;

		$dd = $loop + 15;
		$link = $TB_LINKS[$dd].'<FONT COLOR="#808080"><B>'.$TB_WORDS[$dd].'</B></FONT>'.$href;
		$days = '<FONT COLOR="'.$TB_COLOR[$dd].'">'.$TB_WEEKS[$dd].'</FONT>';
		$date = sprintf("%4d/%02d/%02d",$yyyy,$mm,$dd);

		print qq!
			<TD BGCOLOR="#F5F5F5" ALIGN="right" WIDTH="1%" NOWRAP>$link</TD>
			<TD BGCOLOR="$TB_CELLS[$dd]" ALIGN="right" WIDTH="1%" NOWRAP>$days</TD>
			<TD WIDTH="48%">$LIST_MEMOS{$date}</TD>
		</TR>
		!;
	}

	$dd = 31;
	$link = $TB_LINKS[$dd].'<FONT COLOR="#808080"><B>'.$TB_WORDS[$dd].'</B></FONT>'.$href;
	$days = '<FONT COLOR="'.$TB_COLOR[$dd].'">'.$TB_WEEKS[$dd].'</FONT>';
	$date = sprintf("%4d/%02d/%02d",$yyyy,$mm,$dd);

	print qq!
		<TR>
			<TD BGCOLOR="#F5F5F5" ALIGN="right" WIDTH="1%" NOWRAP></TD>
			<TD BGCOLOR="#F5F5F5" ALIGN="right" WIDTH="1%" NOWRAP></TD>
			<TD WIDTH="48%"></TD>
			<TD BGCOLOR="#F5F5F5" ALIGN="right" WIDTH="1%" NOWRAP>$link</TD>
			<TD BGCOLOR="$TB_CELLS[$dd]" ALIGN="right" WIDTH="1%" NOWRAP>$days</TD>
			<TD WIDTH="48%">$LIST_MEMOS{$date}</TD>
		</TR>
	!;
}

# եؤ¸

sub Save_Logs
{
	my($file,@record) = @_;

	if($SAMPLE_ERROR) {
		$sample = $SAMPLE_ERROR;
		return;
	}

	my($LOCK_FILE) = $file.".lock";

	if(-e $LOCK_FILE) {
		$error = "ߡ̤ѼԤˤԽƤޤ";
		require "user_03.inc";
		exit;
	}

	if(!open(OFILE,">$LOCK_FILE")) {
		$error = "ե˽Ǥޤ";
		require "user_03.inc";
		exit;
	}

	print OFILE join("\n",@record);
	print OFILE "\n" if($#record >= 0);

	close(OFILE);

	if(!rename($LOCK_FILE,$file)) {
		$error = "ե¸˼Ԥޤ";
		require "user_03.inc";
		exit;
	}
	return;
}

1;

# Copyright (C) 2001-2004 All right reserved by Shinya Kondo ( CGI KON )
